

\documentclass[11pt,semhelv,semlayer,semcolor]{seminar}

% \usepackage[latin1]{inputenc}
\usepackage{helvet}
\usepackage{fancybox}
\usepackage{amssymb}

\newcommand{\makedisplay}{}
\input{texpower-seminar.6.tex}

%\renewcommand{\labelitemi}{{\myheadcolor $\bullet$}}
%\renewcommand{\labelitemii}{{\myheadcolor $\hookrightarrow$}}
%\renewcommand{\labelitemiii}{{\myheadcolor $\ast$}}

\setfootcolor{green4}
\setheadcolor{red3}
\settextcolor{black}

\title{Specifying and executing\cuthere
reactive scenarios\cuthere
with Lutin}

\author{
Pascal Raymond\\
Erwan Jahier\\
Yvan Roux}

\address{VERIMAG, Grenoble}

\subject{lutin}

\wherewhen{Slap07, rev. nov. 2010}

\date{}

\titlefooter{
\includegraphics[scale=0.5]{logos/cnrs.pdf}
\hfill
\includegraphics[scale=0.5]{logos/verimag.pdf}
\hfill
\includegraphics[scale=0.5]{logos/grenoble-universites.pdf}
}

\hypersetup{pdftitle={\thetitle},
  pdfsubject={\thesubject},
  pdfauthor={\theauthor},
  %pdfkeywords={pp4, transparents},
  %pdfpagemode={FullScreen},
  %linkcolor={red}
}

\input{commandes}
\input{x11colors}

\newcommand{\trans}[1]{\mbox{$\stackrel{#1}{\longrightarrow}$}}
\newcommand{\vanish}{\raisebox{-0mm}{$\;\rotatebox{90}{$\scriptstyle \hookleftarrow$}$}}
\newcommand{\diewith}[1]{\raisebox{-0mm}{$\;\rotatebox{90}{$\scriptstyle \hookrightarrow$}^{#1}$}}

\begin{document}

\renewcommand{\labelitemi}{{\myheadcolor $\bullet$}}
\renewcommand{\labelitemii}{{\myheadcolor $\hookrightarrow$}}
\renewcommand{\labelitemiii}{{\myheadcolor $\ast$}}

% ne pas mettre dans un \begin{slide} ... \end{slide}
\maketitle

\tocslide{Contents}

%\newcommand{\kw}[1]{\mbox{\color{DeepPink}\small\tt #1}}
\newcommand{\id}[1]{\mbox{\color{black}\small\tt #1}}
\newcommand{\kw}[1]{\mbox{\color{DarkOrange2}\small\tt #1}}
\newcommand{\ty}[1]{\mbox{\color{green4}\small\tt #1}}
\newcommand{\sy}[1]{\mbox{{\color{DarkViolet}\it #1}}}
\newcommand{\cs}[1]{\mbox{{\color{red2}\small\tt #1}}}
\newcommand{\NODE}[1]{\kw{node}}
\newcommand{\RETURNS}[1]{\kw{returns}}
\newcommand {\bnfdef}{\mbox{\ $::=$\ }}
\newcommand {\bnfor}{\mbox{\ $|$\ }}

\newcommand{\OB}{\kw{\symbol{"7B}}}  %{
\newcommand{\CB}{\kw{\symbol{"7D}}}  %}
\newcommand{\BAR}{\kw{\symbol{"7C}}} %|
\newcommand{\SBAR}{\kw{\symbol{"7C}\symbol{"3E}}} %|>
\newcommand{\OS}{\kw{\symbol{"5B}}}  %[
\newcommand{\CS}{\kw{\symbol{"5D}}}  %]
\newcommand{\TI}{\kw{\symbol{"7E}}}  %~
%\newcommand{\EE}{\kw{\symbol{"26}\symbol{"26}}}  %&&
\newcommand{\EA}{\kw{\symbol{"26}\symbol{"3E}}}  %&>
\newcommand{\OP}{\kw{\symbol{"28}}}  %(
\newcommand{\CP}{\kw{\symbol{"29}}}  %)
\newcommand{\COL}{\kw{\symbol{"3A}}}  %)

\newcommand{\LOOPI}[2]{{\kw{loop}\OS\mbox{#1},\mbox{#2}\CS}}
\newcommand{\LOOPA}[2]{{\kw{loop}\TI\mbox{#1}:\mbox{#2}}}

\newcommand{\VARDECL}[2]{#1\kw{:}~\ty{#2}}



\begin{slide}
\section{Introduction}

\subsection{Domain: Reactive Systems}

\begin{itemize}
\item Infinite sequence of reactions, typical hierarchic/parallel systems.
\item Safety critical: (hopefully) deterministic
\end{itemize}

\centerline{\input{appli}}

However: non-determinism could be useful:
\begin{itemize}
\item test purpose: simulate the environment
\item early simulation: simulate ``approximation'' of not yet available modules
\end{itemize}
\end{slide}

%%%%%%%%%

\begin{slide}
\subsection{Goal: describe and simulate}

\begin{itemize}
\item Targeted applications: test, simulation/prototyping ...
\item Define suitable language for describing non.det. systems:\pause
   \begin{itemize}
   \item \RedIII{non-deterministic $\not=$ chaotic}:
   systems should be realistic/interesting according to
   their known temporal properties.\pause
   \item \RedIII{non-determinism is not sufficient}: simulation
   requires some feature to express ``probabilities''
   (e.g. some behavior is more likely to appear than another)
   \end{itemize}
\item Provide tools to animate such description:
   \begin{itemize}
   \item Sound and (simple?) semantics: non.det. should be mastered,
not due to semantics lacks.
   \item A single behavior = hundreds of reactions, thus
simulation should be as efficient as possible.
   \end{itemize}
\end{itemize}

\end{slide}

%%%%%%%%%

\begin{slide}
\subsection{Towards the ``good'' programming style}
\begin{itemize}
\item Declarative style: appealing (necessary ?) for describing constraints
\item Imperative/sequential style: appealing for describing temporal
scenarios.
\end{itemize}\pause
\subsection{Our solution, a two-level language:}
\begin{itemize}
\item declarative (\`a la Lustre) for expressing atomic constraints 
\item control structures for building temporal scenarios 
	\begin{itemize}
	\item inspired by regular expressions 
	\item enriched with complex control structures (cf. Esterel, process algebra)
	\end{itemize}
\end{itemize}
\end{slide}

%%%%%%%%%


% slide 1
\begin{slide}
\section{The language}

\subsection{Reactive systems}
\begin{itemize}
\item
Lutin allows the description of non-deterministic
reactive systems.\\
A system, called a node, is declared with its parameters:\\
{\tt
\kw{node}~foo (x: \ty{int}; y: \ty{bool})\\
\kw{returns}~(a,b:\ty{bool}; c:\ty{int}) = ~\sy{trace-exp}
}
\item
The body \sy{trace-exp} describes the possible behaviors
as a ``language'' whose words are 
{\em constraints} on the parameters (called the {\em support variables}).
\end{itemize}

\end{slide}


%%%%%%%%%%
\begin{slide}

\subsection{Reactions}
\begin{itemize}
\item An atomic behavior is a non-deterministic reaction.
\item It is described as a constraint on the \RedIII{current} and
\RedIII{previous} values of the support variables
(\id{x} and {\tt\kw{pre} \id{x}}):\\
\sy{data-exp} \bnfdef algebraic Boolean expression
\item Thus, variables may be:
\begin{itemize}
\item controllable (outputs),
\item uncontrollable (inputs, \kw{pre}'s).
\end{itemize}
\item Performing an atomic reaction,
for \RedIII{given} values of the uncontrollable variables,
consists in \RedIII{randomly} generating
values for the controllable variables that satisfy the constraint.
\item \RedIII{N.B. if no solution exists, the system deadlocks}
\end{itemize}
\end{slide}

%%%%

\begin{slide}

\subsection{Example}
Let \id{x} be a Boolean input, and \id{c} a real output,
and consider the following constraint~:\\
\centerline{
\tt (\id{x} \kw{and} (\id{c} <= 10.0) \kw{and} (\id{c} > \kw{pre} \id{c}))
}\pause

\begin{itemize}
\item if \id{x} is actually true, and \mbox{\small\tt \kw{pre} \id{c}} $< 10$,
then the constraint admits solutions~:
	\begin{itemize}
	\item the system randomly choose some value
		\id{c} $\in ]\mbox{\small\tt \kw{pre} c},10.0]$
\pause
	\end{itemize}
\item otherwise, the constraint has no solution,
	\begin{itemize}
	\item we say that the constraint ``deadlocks''
\pause
	\end{itemize}
\item this ``local'' deadlock is not necessarily an error:
it is the basic feature for defining the control flow
(as presented in the sequel).
\end{itemize}

\end{slide}

%%%%%

\begin{slide}

\subsection{The basic control flow}

\begin{itemize}
\item Atomic reactions are combined with imperative statements
(called {\em trace expressions}),
\item i.e. they are  embedded into a ``classical'' control structure.
\item basic statements are inspired by regular expressions:
\begin{tabbing}
\sy{trace-exp} \=\bnfdef\= \sy{data-exp}~~~~~~~~~~(must be Boolean) \\
\>\bnfor\> \sy{trace-exp} \kw{fby} \sy{trace-exp}~~~~(sequence)\\
\>\bnfor\> \kw{loop} \sy{trace-exp}~~~~(unbounded loop)\\
\>\bnfor\> \OB \BAR \sy{trace-exp} ... \BAR \sy{trace-exp} \CB
~~~~(non deterministic choice)
%\ \bnfor\ \OB \sy{trace-exp} \SBAR ... \SBAR \sy{trace-exp} \CB
\end{tabbing}
\end{itemize}
\newslide
\subsection{Basic example}
{\tt \begin{smallprogram}
((\id{x} > 0) and (\id{x} <= 10)) \kw{fby}\\
\kw{loop} \OB\\
\> \BAR \> (\id{on} \kw{and} (\id{x} > \kw{pre} \id{x})) \\
\> \BAR \> (\id{x} = \kw{pre} \id{x}) \\
\CB
\end{smallprogram}}
The first \BAR\ symbol can be omitted:
{\tt \begin{smallprogram}
((\id{x} > 0) and (\id{x} <= 10)) \kw{fby}\\
\kw{loop} \OB\\
\> \>  (\id{on} \kw{and} (\id{x} > \kw{pre} \id{x}))\\
\> \BAR\ \> (\id{x} = \kw{pre} \id{x})\\
\CB
\end{smallprogram}}
\end{slide}

%%%%%%%%%

\begin{slide}

\subsection{Other useful statements}
\begin{itemize}
\item \kw{assert} \sy{data-exp} \kw{in} \sy{trace-exp}\\
distributes the constraint \sy{data-exp} (Boolean expression)
all along the behavior \sy{trace-exp}
\item \kw{local} \sy{ident} \kw{:} \sy{type} \kw{in} 
\sy{trace-exp}\\
declares a local support variables (hidden output)
\item \kw{try} \sy{trace-exp} \kw{do} \sy{trace-exp}\\ 
if the left \sy{trace-exp} deadlocks, behaves as the
right one.
\end{itemize}


\end{slide}
\begin{slide}

\subsection{Controlling non-determinism}
\begin{itemize}
\item
relative weights can be attached to choices:\\
\OB
\BAR\sy{w1}\COL\ \sy{trace-exp} ...
\BAR\sy{wn}\COL\  \sy{trace-exp}
\CB
	\begin{itemize}
	\item each \sy{wi} must be a {\em uncontrollable} integer expressions
	\item the default is the constant $1$
	\end{itemize}
\item iterations constrained by an interval:\\
\kw{loop} \OS \sy{min}\kw{,}\sy{max}\CS \sy{trace-exp}\\
where \sy{min} and \sy{max} are {\em static} integer expressions
\item iterations constrained by average and standard deviation:\\
\kw{loop} \TI \sy{av}\kw{:}\sy{sd} \sy{trace-exp}\\
where \sy{av} and \sy{sd} are {\em static} integer expressions
\end{itemize}

\end{slide}
\begin{slide}

\subsection{Instantaneous loops}

\begin{itemize}
\item An iteration loop may be instantaneous:
\item Worst: \kw{loop}~\kw{loop}~\sy{c}
infinitely loops without doing anything if
\sy{c} is not satisfiable
\end{itemize}
\subsection{Well founded loop principle}
A loop may stop of continue, but if it continues it must
generate something not empty.

In terms of regular languages:
$\kw{loop}\; t  \;=\; (t \setminus \varepsilon)^*$

\end{slide}
\begin{slide}

\subsection{Non-determinism, deadlock and probabilities}
\begin{itemize}
\item Reactivity principle: a choice should not deadlock
unless {\em all possibilities} deadlock
\item N.B. reactivity has priority over weights:
\begin{tinyprogram}
\OB\\
\> \BAR 1000000\COL\ \>\>\>\>\> \sy{t1}\\
\> \BAR 1\COL\ \>\>\>\>\> \sy{t2}\\
\CB
\end{tinyprogram}
if \sy{t1} deadlocks and \sy{t2} not, \sy{t2} is chosen, whatever be its actual (tiny) weight
\end{itemize}
\end{slide}

\begin{slide}
\begin{itemize}
\item Example~:
{\small\tt
\OB\ 
\BAR 3\COL\ \sy{X}
\BAR 5\COL\ \sy{Y}
\BAR\ \sy{Z}
\CB
}\\
Actual probabilities are:\\
{\small
\begin{tabular}{|c||c|c|c|c|}
\hline
deadlocking set & X & Y & Z & deadlock \\
\hline
$\emptyset$ & 3/9 & 5/9  & 1/9  &  0 \\
\{X\} & 0 & 5/6  & 1/6  &  0 \\
\{Y\} & 3/4 & 0  & 1/4  &  0 \\
...&...&...&...&...\\
\{X,Y\} & 0 & 0  & 1  &  0 \\
...&...&...&...&...\\
\{X,Y,Z\} & 0 & 0  & 0  &  1 \\
\hline
\end{tabular}
}
\end{itemize}
\end{slide}

\begin{slide}
\subsection{Non-determinism, deadlock and priority}

Even with a tiny weight, the probability to choose 
a branch is not null.
The {\em priority choice} allows to define a notion of
nested infinite weights: 
\begin{itemize}
\item Syntax:
\OB\ 
\SBAR\ \sy{t1} \SBAR\ \sy{t2} ... \SBAR \sy{tn}
\CB
\item \sy{t1} is chosen if it does not deadlock, otherwise \sy{t2} is chosen
if it does not deadlock, etc.
\item the whole statement deadlocks if all branches deadlock 
\item The first \SBAR\ symbol can be omitted
\item Typical example:
\OB
\sy{optimal} \SBAR\ \sy{degraded} \SBAR\ \sy{rescue} \SBAR\ \sy{lost}
\CB
\end{itemize}

\end{slide}
\begin{slide}

\subsection{Concurrency}
\begin{itemize}
\item Syntax~:\\
\OB\ 
\EA\ \sy{trace-exp} ... \EA\ \sy{trace-exp}
\CB
\item All along the execution,
each branch produces its own constraint,
whose conjunction gives the global one.
\item The statement terminates if and when 
all branches have terminated (cf. Esterel).
\item If (at least) one branch deadlocks, the
whole statement deadlocks.
\item The first \EA\ symbol can be omitted.
\end{itemize}

\end{slide}
\begin{slide}

\subsection{Concurrency versus probabilities}
They do not live in harmony ...\\
\OB~\OB \BAR 1000\COL\ \sy{X} \BAR 1\COL\ \sy{Y} \CB
~\EA~
\OB \BAR 1000\COL\ \sy{A} \BAR 1\COL\ \sy{B} \CB
~\CB\\
If \sy{X} and \sy{A} do not deadlock separately, 
while their conjunction does:
\begin{itemize}
\item the most probable behavior can be \sy{Y}\EA\sy{A},
which is unfair for the first branch,
\item or it can be \sy{X}\EA\sy{B},
which is unfair for the second one.
\end{itemize}
\RedII{Design choice:}
\begin{itemize}
\item the first branch ``plays'' first, the second tries to do with it,
etc.
\item i.e., weights are treated in sequence.
\item N.B. The syntax outlines the fact that the statement is not
commutative.
\end{itemize}

\end{slide}
\begin{slide}

\subsection{Exceptions}
They allow to bypass the {\em normal} control-flow.
They resemble classical exceptions (caml, Java etc.)
and also Esterel trap signals. 
\begin{itemize}
\item Declaration/scope:\\
\kw{exception} \sy{ident}~~~{{-}- global}\\
\kw{exception} \sy{ident} \kw{in} \sy{trace-exp}
~~~{{-}- local}
%n.b. global exceptions cannot be shadowed.
\item Raise statement:
\kw{raise} \sy{ident}
\item Catching point:\\
\kw{catch} \sy{ident} \kw{in} \sy{t1} \kw{do} \sy{t2}\\ 
if \sy{ident} is raised within \sy{t1}, the control passes
immediately to \sy{t2}.
\newslide
\item Shortcut: \kw{trap} \sy{x} \kw{in} \sy{t1} \kw{do} \sy{t2}\\ 
for~:
\kw{exception} \sy{x} \kw{in}
\kw{catch} \sy{x} \kw{in} \sy{t1} \kw{do} \sy{t2}
\item Deadlock: is equivalent to the raise
of a {\em predefined} exception.\\
\kw{catch} \cs{DeadLock} \kw{in} \sy{t1} \kw{do} \sy{t2}\\
is equivalent to: \kw{try} \sy{t1} \kw{do} \sy{t2}
\item Exception and concurrency:
\begin{itemize}
\item there is no ``multiple'' raise,
\item just like weights, \kw{raise} statements are treated in sequence,
from left to right.
\item e.g. 
{\OB \kw{raise} E \EA \sy{X} \CB}
$\equival$
{\kw{raise} E}
\end{itemize}
\end{itemize}

\newslide

\subsection{Modularity}
The language provides a ``functional'' layer in order to:
\begin{itemize}
\item share definitions,
\item define and re-use new operators,
for both data and behaviors.
\item An (abstract) type \ty{trace} is defined, in order to
characterize behavior operators and parameters.
\item The semantics is simply defined in terms of
substitution (macros rather than functions).
\newslide
\item A macro can be global
(outside a particular \kw{node})~:\\
\kw{let} \sy{ident} \OP \sy{params} \CP \kw{:} \sy{type}
\kw{=} \sy{exp}\\
\sy{exp} is either a \sy{trace-exp} or a \sy{data-exp},
according to its \sy{type}.
\item or it can be local to a \sy{trace-exp}:\\
\kw{let} \sy{ident} \OP \sy{params} \CP \kw{:} \sy{type}
\kw{=} \sy{exp} \kw{in} \sy{exp}\\
in which case, classical scope rules hold.
\item Input \sy{params}, and output \sy{type} are optional.
\item \Red{Beware to not mistake support variables
with input-free macros (aliases)}
\end{itemize}
\newslide

\subsection{Examples}
\begin{itemize}

\item data combinator: the ``interval'' relation
{\tt\begin{tabbing}
\kw{let} within\=(x,~min,~max:~\ty{real}):~\ty{bool}~=\\
  \>  (min <= x) \kw{and} (x <= max)
\end{tabbing}}
%\newslide
%\subsection{Example}
\item trace combinator: the initial constraint
{\tt \begin{tabbing}
\kw{let} \= assert\_init\OP\VARDECL{init}{bool}\kw{;} \VARDECL{t}{trace}\CP
\kw{:} \ty{trace} \kw{=} \\
 \kw{trap} Stop \kw{in} \OB\\
	\>	init \sy{{-}- implicit cast bool/(1-length) trace}\\
	\EA \\
%	\>	\sy{{-}- si t termine immédiatement, on n'impose pas init}\\
	\> t \kw{fby} \kw{raise} Stop\\
	\CB\\
\end{tabbing}}
\end{itemize}

\newslide
\subsection{Examples}
\begin{itemize}
\item Concurrent execution that terminates as soon as the second branch terminates:
{\tt
\begin{tabbing}
\kw{let} \= as\_long\_as(X, Y : \ty{trace}) : \ty{trace} =\\
    \> \kw{trap} \= Stop \kw{in}\\
    \>      \> X  \EA~\OB Y \kw{fby} \kw{raise} Stop\CB\\
    \> \CB
\end{tabbing}}
%\newslide
\item Or as soon as one branch terminates:
{\tt
\begin{tabbing}
\kw{let} \= racing(X, Y : \ty{trace}) : \ty{trace} =\\
    \> \kw{trap} \= Stop \kw{in}\\
    \>  ~~\OB X \kw{fby} \kw{raise} Stop\CB~\EA~\OB Y \kw{fby} \kw{raise} Stop\CB\\
    \> \CB 
\end{tabbing}
}
\end{itemize}
\end{slide}
\begin{slide}

\subsection{Parameters and support variables}
\begin{itemize}
\item The type \ty{trace} is rather abstract: what about the
support~?
\item Actually, it \RedII{does not matter}:\\
trace operators (pre- or user-defined) are 
in general \RedII{polymorphic}.
\item If a support variable is specifically expected as argument,
the type must be over-specified:
\sy{x}\kw{:} \sy{type} \ty{ref}\\
In this case, the type-checking will reject any call where
the actual argument is not a support variable.
\item N.B. the flag \ty{ref} is not really necessary unless
some \kw{pre} operator is used within the macro:\\
\kw{let} foo \OP \VARDECL{x}{bool}\CP = ... \kw{pre} x ... \sy{{-}- TYPE ERROR}\\
\kw{let} foo \OP \VARDECL{x}{bool ref}\CP = ... \kw{pre} x ... \sy{{-}- OK}
\end{itemize}
\end{slide}

\begin{slide}
\subsection{Example}
The ``first-order-filter'' relation:
{\tt\begin{tabbing}
\kw{let} fof \= (y:~\ty{real ref}; x,~gain:~\ty{real}):~\ty{bool} =\\
        \> (y = gain*(pre y) + (\cs{1.0}-gain)*x)
\end{tabbing}}
\end{slide}

\begin{slide}
\subsection{Example}
A whole system:
\begin{itemize}
\item Output {\tt x} tends to input {\tt t} when input {\tt c}
is true, otherwise tends to 0.
\item The system works almost properly for about 1000 reactions:
it may ``miss'' some {\tt c} commands (1 times out of 10).
\item Then it breaks down, and {\tt x} quickly tends to 0.
\end{itemize}
\newslide
{\tt\small\begin{tabbing}
\kw{node} \=foo(c:~\ty{bool};~t:\ty{real}) \kw{returns} (x:~\ty{real}) =  \\
   \> within(x, \cs{-100.0}, \cs{100.0})  \kw{fby}  \\
   \> \kw{local} a: \ty{real} \kw{in}  \\
	\> \kw{let}\=~gen\_gain():~\ty{trace} = \kw{loop} \OB\\
	\> \> within(a, \cs{0.8}, \cs{0.9})\\
   \> \> \kw{fby} \LOOPI{\cs{30}}{\cs{40}} (a = \kw{pre} a)  \\
	\> \CB\ \kw{in}\= \\
   \> as\_long\_as (  \\
   \>   \> gen\_gain(),\\
   \>   \>  \kw{loop}\=\TI\cs{1000}\kw{:}\cs{100} \OB\\
   \>   \>  \>  (c \kw{and} fof(x, a, t)) \kw{weight} 9  \\
   \>   \>  \BAR\ \> fof(x, a, \cs{0.0})  \\
   \>   \>  \CB  \\
   \> ) \kw{fby}  \kw{loop} fof(x, \cs{0.7}, \cs{0.0})
\end{tabbing}}
\newslide
\begin{center}
\scalebox{.9}{\includegraphics{chrono.pdf}}
\end{center}
\end{slide}

\begin{slide}

\section{Conclusion}

\begin{itemize}
\item A language mixing relational constraints within a control structure.
\item Operational semantics formally defined (cf. paper).
\item Programs can be:
	\begin{itemize}
	\item interpreted
	\item compiled into (ad hoc) non-deterministic/stochastic automata
	\end{itemize}
\end{itemize}
\subsection{Note on constraint solving}
\begin{itemize}
\item The actual solver handles both logical and linear constraints
(by means of BDDs and convex polyhedra).
\item It is the ``hard'' (and costly) part of the tool ...
\item ... but it can be easily replaced/adapted for simpler
theory:
	\begin{itemize}
	\item in most cases, an interval solver is sufficient (and much more efficient)
	\end{itemize}
\end{itemize}

%\label{lastpage}
\end{slide}

\end{document}

